Index: trunk/NEMO/TOP_SRC/trcsms.F90
===================================================================
--- trunk/NEMO/TOP_SRC/trcsms.F90	(revision 944)
+++ trunk/NEMO/TOP_SRC/trcsms.F90	(revision 945)
@@ -1,172 +1,76 @@
 MODULE trcsms
-   !!===========================================================================================
-   !!
-   !!                       *** MODULE trcsms ***
-   !!
-   !!  Time  loop of opa for passive tracer
-   !!
-   !!===========================================================================================
-   !!  TOP 1.0,  LOCEAN-IPSL (2005) 
-   !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !!======================================================================
+   !!                         ***  MODULE trcsms  ***
+   !! TOP :   Time loop of passive tracers sms
+   !!======================================================================
+   !! History :   1.0  !  2005-03 (O. Aumont, A. El Moussaoui) F90
+   !!             2.0  !  2007-12  (C. Ethe, G. Madec)  revised architecture
    !!----------------------------------------------------------------------
-#if defined key_passivetrc   
-   !! * Modules used
-   !! ==============
-   USE oce_trc
-   USE trc
-   USE trcfreons
-   USE prtctl_trc          ! Print control for debbuging
+#if defined key_top
+   !!----------------------------------------------------------------------
+   !!   'key_top'                                                TOP models
+   !!----------------------------------------------------------------------
+   !!   trc_sms        :  Time loop of passive tracers sms
+   !!----------------------------------------------------------------------
+   USE oce_trc            !
+   USE trc                !
+   USE trcsms_lobster     ! LOBSTER bio-model
+   USE trcsms_pisces      ! PISCES biogeo-model
+   USE trcsms_cfc         ! CFC 11 & 12 
+   USE trcsms_my_trc      ! MY_TRC  tracers
+   USE prtctl_trc         ! Print control for debbuging
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Accessibility
-   PUBLIC trc_sms
+   PUBLIC   trc_sms    ! called in trcstp.F90
+
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 2.0 , LOCEAN-IPSL (2007) 
+   !! $Header:$ 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 
 CONTAINS
 
    SUBROUTINE trc_sms( kt )
-      !!===========================================================================================
+      !!---------------------------------------------------------------------
+      !!                     ***  ROUTINE ini_trc  ***
       !!
-      !!                       ROUTINE trcsms
-      !!                     *****************
+      !! ** Purpose :   Managment of the time loop of passive tracers sms 
       !!
-      !!  PURPOSE :
-      !!  ---------
-      !!          time loop of opa for passive tracer
+      !! ** Method  : -  call the main routine of of each defined tracer model
+      !! -------------------------------------------------------------------------------------
+      INTEGER, INTENT( in ) ::   kt      ! ocean time-step index      
       !!
-      !!   METHOD :
-      !!   -------
-      !!      compute the well/spring evolution
-      !!
-      !!   INPUT :
-      !!   -----
-      !!      argument
-      !!              ktask           : task identificator
-      !!              kt              : time step
-      !!      COMMON
-      !!            all the COMMON defined in opa
-      !!
-      !!
-      !!   OUTPUT :			: no
-      !!   ------
-      !!
-      !!   WORKSPACE :
-      !!   ---------
-      !!
-      !!   EXTERNAL :
-      !!   --------
-      !!      trcbio, trcsed, trcopt for NPZD or LOBSTER1 models
-      !!
-      !!      h3cprg for HAMOC3 and P3ZD models
-      !!
-      !!
-      !!   History:
-      !!   --------
-      !!      original  : 96-11
-      !!      additions : 99-07 (M. Levy)
-      !!                  04-00 (O. Aumont, M.A. Foujols) HAMOCC3 and P3ZD
-      !!                  12-00 (O. Aumont, E. Kestenare) add trcexp for instantaneous export 
-      !!   05-03 (O. Aumont and A. El Moussaoui) F90
-      !! -------------------------------------------------------------------------------------
+      CHARACTER (len=25) :: charout
+      !!---------------------------------------------------------------------
 
-      !! * Arguments
-      !! -----------
-      INTEGER, INTENT( in ) ::   kt      ! ocean time-step index      
+      IF ( MOD(kt,ndttrc) /= 0) RETURN      ! this ROUTINE is called only every ndttrc time step
 
-      !! * Local variables
-      !! -----------------
+      IF( lk_lobster )   CALL trc_sms_lobster( kt )    ! main program of LOBSTER
+      IF( lk_pisces  )   CALL trc_sms_pisces ( kt )    ! main program of PISCES 
+      IF( lk_cfc     )   CALL trc_sms_cfc    ( kt )    ! surface fluxes of CFC
+      IF( lk_my_trc  )   CALL trc_sms_my_trc ( kt )    ! MY_TRC  tracers
 
-      CHARACTER (len=25) :: charout
-
-      !! this ROUTINE is called only every ndttrc time step
-      !! --------------------------------------------------
-
-      IF ( MOD(kt,ndttrc) /= 0) RETURN
-
-      !! this first routines are parallelized on vertical slab
-      !! ------------------------------------------------------
-
-#if defined key_trc_lobster1
-
-      !! tracers: optical model
-      !! ----------------------
-
-      CALL trcopt( kt)
-
-      IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
-         WRITE(charout, FMT="('OPT')")
-         CALL prt_ctl_trc_info(charout)
-         CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
+      IF(ln_ctl) THEN      ! print mean trends (used for debugging)
+         WRITE(charout, FMT="('sms ')")
+         CALL prt_ctl_trc_info( charout )
+         CALL prt_ctl_trc( tab4d=trn, mask=tmask, clinfo=ctrcnm )
       ENDIF
-
-      !! tracers: biological model
-      !! -------------------------
-
-      CALL trcbio( kt)
-
-      IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
-         WRITE(charout, FMT="('BIO')")
-         CALL prt_ctl_trc_info(charout)
-         CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
-      ENDIF
-
-      !! tracers: sedimentation model
-      !! ----------------------------
-
-      CALL trcsed(kt)
-      IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
-         WRITE(charout, FMT="('SED')")
-         CALL prt_ctl_trc_info(charout)
-         CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
-      ENDIF
- 
-      CALL trcexp(kt)
-
-      IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
-         WRITE(charout, FMT="('EXP')")
-         CALL prt_ctl_trc_info(charout)
-         CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
-      ENDIF
-
-#elif defined key_trc_pisces
-
-      !! p4zprg: main PROGRAM for PISCES 
-      !! -------------------------------
-      CALL p4zprg(kt)
-
-      !! SMS to DO
-
-#elif defined key_cfc
-
-      !! CFC's code taken from K. Rodgers
-
-      !! This part is still experimental
-      !! -------------------------------
-
-      CALL trc_freons(kt)
-
-#endif
-
-
-
+      !
    END SUBROUTINE trc_sms
 
 #else
    !!======================================================================
-   !!  Empty module : No passive tracer
+   !!  Dummy module :                                     No passive tracer
    !!======================================================================
 CONTAINS
-
-   SUBROUTINE trc_sms( kt )
-
-      ! no passive tracers
+   SUBROUTINE trc_sms( kt )                   ! Empty routine
       INTEGER, INTENT( in ) ::   kt
       WRITE(*,*) 'trc_sms: You should not have seen this print! error?', kt
    END SUBROUTINE trc_sms
-
 #endif 
 
-
+   !!======================================================================
 END MODULE  trcsms
